import * as tslib_1 from "tslib";
import React from 'react';
import { ScrollView } from 'react-native';
import validate from 'validate.js';
var Form = /** @class */ (function (_super) {
    tslib_1.__extends(Form, _super);
    function Form(props) {
        var _this = _super.call(this, props) || this;
        _this.state = tslib_1.__assign({}, props.fields, { errors: {} });
        _this.setValue = _this.setValue.bind(_this);
        _this.submit = _this.submit.bind(_this);
        _this.validate = _this.validate.bind(_this);
        return _this;
    }
    Form.prototype.render = function () {
        var _a = this.props, children = _a.children, style = _a.style;
        return (<ScrollView keyboardShouldPersistTaps="handled" contentContainerStyle={style}>
        {children({
            fields: this.state,
            setValue: this.setValue,
            submit: this.submit,
            errors: this.state.errors
        })}
      </ScrollView>);
    };
    Form.prototype.setValue = function (key, value) {
        var _a;
        this.setState((_a = {}, _a[key] = value, _a));
    };
    Form.prototype.submit = function () {
        var _this = this;
        var _a = this.props, onSubmit = _a.onSubmit, onError = _a.onError;
        this.validate().then(function (valid) {
            if (valid) {
                var fields = tslib_1.__assign({}, _this.state);
                delete fields.errors;
                if (onSubmit) {
                    onSubmit(fields);
                }
            }
            else if (onError) {
                onError(_this.state.errors);
            }
        });
    };
    Form.prototype.validate = function () {
        var _this = this;
        return new Promise(function (resolve) {
            var errors = validate.validate(_this.state, _this.props.validator, {
                fullMessages: false
            });
            _this.setState({ errors: errors || {} });
            resolve(!!!errors);
        });
    };
    return Form;
}(React.Component));
export { Form };
//# sourceMappingURL=Form.js.map